* Copyright (c) 1990 by AT&T Bell Telephone Laboratories, Incorporated. */
* The C++ Answer Book */
* Tony Hansen */
* All rights reserved. */
tatic tree* get_expr(istream& input)

   tree* left = term(input);

   for (;;)
switch (curr_tok.type)
    {
    case PLUS:
        plus_op *headp = new plus_op;
	headp->left = left;
	get_token(input);	// eat '+'
	headp->right = term(input);
	left = headp;
	break;

    case MINUS:
	binary_minus_op* headm = new binary_minus_op;
	headm->left = left;
	get_token(input);	// eat '-'
	headm->right = term(input);
	left = headm;
	break;

    default:		// collapse node
	return left;
    }

